QGIS Application - Bug report #20961
QGIS Server 3.4 can't reset numeric field using WFS Update
2019-01-10 09:20 AM - Uro$ Preloznik

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: QGIS Server

Affected QGIS version:3.5(master) Regression?: Yes
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 28780
Description

When doing WFS update transaction on any numeric field QGIS Server rejects null value. That would make sense only if the field cannot
have null value, but this happens always for numeric fields. In this example is PostGIS table and field is integer and can contain null
values.

To reproduce this is really simple just try to reset any numeric field to NULL value using WFS Update transaction and it will be rejected.
It's a regression because it's working normally on 2.18.

It's the same using WFS 1.1.0 and 1.0.0
Transaction is correctly formed and QGIS Server result is below:

<WFS_TransactionResponse xmins:xsi="http://www.w3.0rg/2001/XMLSchema-instance" version="1.0.0"
xmins="http://www.opengis.net/wfs" xsi:schemal ocation="http://www.opengis.net/wfs
http://schemas.opengis.net/wfs/1.0.0/wfs.xsd" xmiIns:ogc="http://www.opengis.net/ogc">
<TransactionResult>

<Status>

<ERROR/>

</Status>

<Locator>Insert:polygons</Locator>

<Message>Property conversion error on layer insert 'polygons'</Message>
</TransactionResult>
</WFS_TransactionResponse>

Associated revisions

Revision 71e01168 - 2019-01-23 10:45 PM - Alessandro Pasotti
Server WFS NULL values support

- expose nillable in describefeaturetype

- serve xsi:nil="true" in getfeature

- check for NULL in transactions and report an error

Fixes #20961 - plus some other unreported

History

#1 - 2019-01-10 09:49 AM - Alessandro Pasotti
- Status changed from Open to Feedback

Please attach a minimal test project and data, it will speed-up debugging.

#2 - 2019-01-10 11:21 AM - Uros Preloznik
- File wfs test.qgs added

- Status changed from Feedback to Open

- File points.sql added

Adding

1) QGIS project with WFS layers from test.level2.si server

2) points.sql data from PG (to see table structure, we are looking field name "type" with type integer, yes field name "type", not very original)

Steps to reproduce issue:

1. Open project

2. Edit point layer and reset value in field "type" to NULL for any feature.

3. Save changes and you will get Property Conversion error.

Another thing to note is that in database there are records with NULL value in "type" field, but QGIS shows them all as 0

#3 - 2019-01-21 10:58 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#4 - 2019-01-24 10:22 AM - Alessandro Pasotti

- Status changed from Open to In Progress

- Pull Request or Patch supplied changed from No to Yes
- Affected QGIS version changed from 3.4.3 to 3.5(master)

This wasn't easy and I've fixed another bunch of issues along the way:
PR https://github.com/qgis/QGIS/pull/8958

#5 - 2019-01-24 11:22 AM - Uro$ Preloznik

Thank you for this. I'll test it once it is merged and in nightly build.

#6 - 2019-01-24 05:42 PM - Alessandro Pasotti
- % Done changed from 0 to 100
- Status changed from In Progress to Closed

Applied in changeset commit:qgis|71e01168fe43a95002674baf07b3b9b4828b5a08.

2025-05-18 2/3


https://github.com/qgis/QGIS/pull/8958

Files

points.sql 8.96 KB 2019-01-10 Uros Preloznik
wfs test.qgs 449 KB 2019-01-10 Uros Preloznik
